/**
* Programa no bom estilo bacalhau que une todos os PRGs em um grande PRGzo antes de compilar um projeto, isto resolve problemas com PRGs de mesmo nome em pastas diferentes e tambm a visibilidade das classes 
* dentro de uma lib para ser instanciadas atravs de macros ou blocos de cdigo. Infelizmente, recurssos como classes static que poderiam ter o mesmo nome conceitual dentro de prgs diferentes criaro erros de compilao.
* o Demode recebe como parametro um arquivo de configurao, especificando o arquivo hbp que ser executado no final e um make.demode montando os PRGzes no seguinte formato.
*
* make.demode
* 
* CLASSES. PRG
* except INUTIL.PRG,pastaDesnecessaria,testes.prg
* c:\fontes\projeto1\classes
* c:\fontes\projeto1\outrasClasses
* 
* OUTRO.PRG
* c:\fontes\projeto1\soltos
*/

#include "FileIO.ch"
#include "Directry.ch"
#include "xhb.ch"

//static hbcName
static demodeName

static demodeFile
static prgzaoFile := 0

static except

function Main(cDemodeName)
	if(pcount() < 1)
		? 'Use demode <NomeArquivoDemode>'
	endif
	
	//hbcName := cHbcName
	demodeName := cDemodeName
	
	parseDemode()
	fclose(prgzaoFile)
	
return 0

function openFile()
	demodeFile := fopen(demodeName, FO_READ )	
	IF FError() <> 0
		? "Erro ao abrir o arquivo: " + demodeName
		quit
	ENDIF
return 0

function parseDemode()
	local cLine
	openFile()
	
	DO WHILE HB_FReadLine( demodeFile, @cLine ) == 0
		parseLine(cLine)		
	ENDDO
	parseLine(cLine)	
	
return 0

function parseLine(cLine)
	local nTam, cFinal, cIni, cIgnore
	cLine := alltrim(cLine)
	nTam := len(cLine)
	
	if(nTam<=1)
		return 0
	endif
	
	cFinal := substr(cLine, nTam - 3)
	cIni := substr(cLine, 1, 6)
	cIgnore := substr(cLine, 1, 1)
		
	//Ignora comentrios
	if(cIgnore == '#')
		return 0
	endif
	
	/*Se a linha comea com except, adiciona exeo*/
	if(upper(cIni) == 'EXCEPT')
		? 'Adicionando exceo: ' + cLine
		return defineExcept(cLine)
	endif
		
	/*Se a linha termina com .PRG deve-se criar um novo PRGZAO para acumular os PRGs das pastas informadas*/	
	if(upper(cFinal) == '.PRG')
		? 'Criando PRG cumulativo: ' + cLine
		return createPrgzao(cLine)
	endif
	
	/*Outras linhas so diretrios que devem ser varridos e copiados dentro do prgzo*/
	? "Copiando Prgs em: " + cLine
	copyFiles(cLine)
return 0

function defineExcept(cList)
	except := substr(cList, 6)
return 0

function createPrgzao(name)
	if(prgzaoFile>0)
		fclose(prgzaoFile)
	endif
	
	prgzaoFile := fcreate(name)
	IF FError() <> 0
		? "Erro ao criar o arquivo: " + name
		quit
	ENDIF
return 0

function copyFiles(cPath)
	local diretorio, arquivo
	
	if(!IsDirectory(cPath))
		? cPath + ' no  um diretorio'
		quit
	endif
	
	if(DirChange(cPath)!=0)
		? 'Erro ao posicionar em ' + cPath
		quit
	endif
	
	diretorio := Directory( "*.*" , 'D')
	
	/*Se retornar apenas o . e o ..*/	
	if len(diretorio) <= 2
		return 0
	endif
	
	//Copia CH
	for each arquivo in diretorio		
		if(!arquivo[F_ATTR]=='D' .AND. arquivo[F_NAME]!='.' .AND. arquivo[F_NAME]!='..')			
			if(upper(substr(alltrim(arquivo[F_NAME]),len(alltrim(arquivo[F_NAME])) - 2)) == '.CH')
				if(!arquivo[F_NAME] $ except)
					? 'Adicionando ' + cPath + '/' + arquivo[F_NAME]
					copyFile(cPath + '/' + arquivo[F_NAME])
				endif
			endif
		endif		
	next
	
	//Copia PRG
	for each arquivo in diretorio		
		if(!arquivo[F_ATTR]=='D' .AND. arquivo[F_NAME]!='.' .AND. arquivo[F_NAME]!='..')			
			if(upper(substr(alltrim(arquivo[F_NAME]),len(alltrim(arquivo[F_NAME])) - 3)) == '.PRG')
				if(!arquivo[F_NAME] $ except)
					? 'Adicionando ' + cPath + '/' + arquivo[F_NAME]
					copyFile(cPath + '/' + arquivo[F_NAME])
				endif
			endif
		endif		
	next
	
	//Pesquisa subdiretorios
	for each arquivo in diretorio		
		if(arquivo[F_ATTR]=='D' .AND. arquivo[F_NAME]!='.' .AND. arquivo[F_NAME]!='..')
			if(!arquivo[F_NAME] $ except)
				? 'Entrando em ' + cPath + '/' + arquivo[F_NAME]
				copyFiles(cPath + '/' + arquivo[F_NAME])
			endif
		endif		
	next
	
return 0

function copyFile(fileName)
	static fCopy := 0
	local cLine
	
	fCopy = fopen(fileName)
	IF FError() <> 0
		? "Erro ao abrir o arquivo: " + fileName
		quit
	ENDIF
	
	copyLine('/* ' + fileName + ' */')
	copyLine(HB_OsNewLine())
	copyLine(HB_OsNewLine())
	
	DO WHILE HB_FReadLine( fCopy, @cLine ) == 0
		copyLine(cLine)		
	ENDDO
	copyLine(cLine)
	
	copyLine(HB_OsNewLine())
	copyLine(HB_OsNewLine())
	
	fclose(fCopy)
return 0

function copyLine(cLine)
	if(prgzaoFile==0)
		? 'Nenhum PRG cumulativo especificado'
		quit
	endif
	
	if(substr(cLine, len(cLine)-len(HB_OsNewLine())) != HB_OsNewLine())
		cLine = cLine + HB_OsNewLine()
	endif
	
	fwrite(prgzaoFile, cLine)	
return 0